<template>
  <section class="app-main">

    <!--    1.初始类型 fade-transform-->
    <div v-if="$store.state.settings.animationType==='fade-transform'">
      <transition name="fade-transform" mode="out-in">
        <keep-alive :include="cachedViews">
          <router-view :key="key" />
        </keep-alive>
      </transition>
    </div>
    <!--2.无类型 none-->
    <div v-else-if="$store.state.settings.animationType==='none'">
      <keep-alive :include="cachedViews">
        <router-view :key="key" />
      </keep-alive>
    </div>
    <!--3.展开折叠类型  el-collapse-transition-->
    <div v-else-if="$store.state.settings.animationType==='el-collapse-transition'">
      <el-collapse-transition>
        <keep-alive :include="cachedViews">
          <router-view :key="key" />
        </keep-alive>
      </el-collapse-transition>
    </div>
    <!--4.剩下的类型 -->
    <div v-else>
      <transition :name="$store.state.settings.animationType">
        <keep-alive :include="cachedViews">
          <router-view :key="key" />
        </keep-alive>
      </transition>
    </div>

  </section>
</template>

<script>
export default {
  name: 'AppMain',
  computed: {
    // 需要缓存的页面 固钉
    cachedViews() {
      return this.$store.state.tagsView.cachedViews
    },
    key() {
      return this.$route.fullPath
    }
  }
}
</script>

<style lang="scss" scoped>
.app-main {
  /* 50= navbar  50  */
  min-height: calc(100vh - 100px);
  width: 100%;
  position: relative;
  overflow: hidden;
}

.fixed-header + .app-main {
  padding-top: 50px;
}

.hasTagsView {
  .app-main {
    /* 84 = navbar + tags-view = 50 + 34 */
    min-height: calc(100vh - 84px);
  }

  .fixed-header + .app-main {
    padding-top: 84px;
  }
}
</style>
